<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <title>Steam Stats</title>
        <link rel="stylesheet" href="../static/css/style.css">
        <link rel="icon" href="../static/rsc/favicon.ico">

        <!-- Should be put in a separate file ? TODO -->
        <script>
            window.onload = function () {
                fetch("static/jsonFiles/onlyGames.json")
                .then((response) => response.json())
                .then((data) => {
                var dataList = document.querySelector("#games-list");
                    
                // Clear current options
                dataList.innerHTML = "";

                // Add new options
                data.forEach(function (app) {
                    var option = document.createElement("option");
                    option.value = app.name;
                    dataList.appendChild(option);
                });
                });
            
                // Get the top relesed games
                fetch("/api/getTopReleases")
                    .then((response) => response.json())
                    .then((data) => {
                        console.log("Added top releases");

                        // Get the appids of the latest month
                        var latestMonth = data.response.pages[0];
                        var appids = latestMonth.item_ids.map(item => item.appid);

                        // Limit the appids to the first 10
                        appids = appids.slice(0, 10);

                        // Clear the current list
                        var topReleasesElement = document.getElementById("top-releases");
                        topReleasesElement.innerHTML = "<table class='games-table' id='top-releases-table'></table>";

                        // Add the appids to the list
                        appids.forEach(function (appid, index) {
                            fetch("/api/" + appid + "/gameName")
                                .then((response) => response.json())
                                .then((data) => {
                                    var topReleasesTable = document.getElementById("top-releases-table");
                                    var urlReadyName = encodeURIComponent(data.name);
                                    topReleasesTable.innerHTML += `<tr><td> - </td><td><a href=/gameInfo?name=${urlReadyName}> ` + data.name + "</a></td></tr>";
                                });
                        });
                    });


                    // Get the top relesed games
                fetch("/api/topGamesByPlayerNumber")
                    .then((response) => response.json())
                    .then((data) => {
                        console.log("Added top games by player number");

                        // Get the ranks of the top games
                        var topGames = data.response.ranks;
                        console.log(topGames);

                        // Cut off all games beyond the top 10
                        topGames = topGames.slice(0, 10);

                        // Clear the current list
                        var topReleasesElement = document.getElementById("top-games");
                        topReleasesElement.innerHTML = "";

                        // Fetch the game names for all games
                        var promises = topGames.map(game => 
                            fetch("/api/" + game.appid + "/gameName")
                                .then(response => response.json())
                                .then(gameName => {
                                    game.name = gameName.name;
                                    return game;
                                })
                        );

                        // Once all game names have been fetched, display the games
                        Promise.all(promises)
                            .then(games => {
                                var tableHTML = '<table class="games-table">';
                                games.forEach(game => {
                                    var urlReadyName = encodeURIComponent(game.name);
                                    tableHTML += "<tr><td><span style=\"color:grey;\"> " + game.rank + `.</span></td><td><a href=/gameInfo?name=${urlReadyName}> ` + game.name + "</a></td><td> <span class=\"player-count\"> " + game.concurrent_in_game.toLocaleString('fr-CH') + "</span> in-game</td></tr>";
                                });
                                tableHTML += '</table>';
                                topReleasesElement.innerHTML = tableHTML;
                            });
                    })
            };
        </script>
    </head>
    <body>
        <h1 class="page-title"> Steam Stats </h1>

        <div class="container">
            <div class="search-container" style="margin-bottom: 5px;">
                <form action="/api/search-game" method="post">
                    <!--The name is what Flask uses in the app.py to receive the inputs-->
                    <input type="text" id="search-bar" name="search-bar"
                        class="search-input"
                        placeholder="Search Steam games" list="games-list">
                    <datalist id="games-list">
                        <!-- Options will be added here by the JavaScript code -->
                    </datalist>
                    <input type="submit" class="search-button"
                        value="Search">
                </form>
            </div>

            <!-- User Search Form -->
            <div class="search-container">
                <form action="/api/search-user"
                    method="post">
                    <!-- The name is what Flask uses in the app.py to receive the inputs -->
                    <input type="text" id="user-search-bar"
                        name="user-search-bar" class="search-input"
                        placeholder="Search Steam users">
                    <input type="submit" class="search-button" value="Search">
                </form>
            </div>

            <!--Refresh game list button-->
            <div>
                <button class="refresh-button">Refresh Game List</button>
            </div>

            <!--Stats Boxes-->
            <div class="stat-boxes">
                <div class="stat-box">
                    <h3>Top Played Games</h3>
                    <ul class="stat-list" id="top-games">
                    </ul>
                </div>
                <div class="stat-box">
                    <h3>Newest Releases</h3>
                    <ul class="stat-list" id="top-releases">
                    </ul>
                </div>
            </div>
        </div>
        <script src="../static/js/script.js"></script>
    </body>
</html>